/*
	 Copyright (C) 2003 Paul Brossier

	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.

	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.

	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	 
*/

/** 
 * @mainpage 
 *
 *  These sections are still to fill.
 *  
 * \section whatis What is it ?
 *
 * 	Aubio is a small library for processing audio (flags for multiple platforms 
 * 	are still missing).
 * 	
 * 	Right now, it depends on the following library :
 * 	 - sound file 	(libsndfile,	 >1.0.4,		[linux, osx, win])
 * 	 - jack 				(libjack, 		 >0.75.0,		[linux, osx			])
 * 	 - libsamplerate(libsamplerate,>0.0.15,		[linux, osx, win])
 *
 * 
 *	Aubio implements the following tools :
 *	 - phase vocoder
 *	 - onset detection
 *	 - up/downsampling
 * 
 * \section howto How do i use it ?
 *
 * Write a small program, which includes aubio.h, and is linked against that library.
 * 
 * Some examples programs are available here :
 *
 * 	http://138.37.33.189/cgi-bin/viewcvs.cgi/aubio/examples/
 *
 */

#ifndef AUBIO_H
#define AUBIO_H

/**
 * Global Aubio include file.
 * Programmers just need to include this file as:
 *
 * @code
 *   #include "aubio.h"
 * @endcode
 *
 * @file aubio.h
 */

#include "fft.h"
#include "phasevoc.h"
#include "mathutils.h"
#include "sample.h"
#include "scale.h"
#include "hist.h"
#include "onsetdetection.h"
#include "tss.h"
#include "resample.h"
#include "jackio.h"
#include "sndfileio.h"
#include "peakpick.h"

#endif

