
#include "aubio_priv.h"
#include "sample.h"
#include "mathutils.h"
#include "biquad.h"

struct _biquad_t {
	//[b,a]=butter(2,0.34);
	float a2;// =-0.5949
	float a3;// = 0.2348
	float b1;// = 0.1600
	float b2;// = 0.3200
	float b3;// = 0.1600
	float o1;
	float o2;
	float i1;
	float i2;
};

//float i1=0., i2=0., o1=0., o2=0.;

void biquad_do(biquad_t * b, fvec_t * in) {
	unsigned int i,j;
	float i1 = b->i1;
	float i2 = b->i2;
	float o1 = b->o1;
	float o2 = b->o2;
	float a2 = b->a2;
	float a3 = b->a3;
	float b1 = b->b1;
	float b2 = b->b2;
	float b3 = b->b3;
	
	i=0; // works in mono only !!!
	//for (i=0;i<in->channels;i++) {
		for (j = 0; j < in->length; j++) {
			float i0 = in->data[i][j];
			/*
			if (isnan(i0) || ABS(isinf(i0)))
				i0 = 1e-37;
				*/
			float o0 = b1 * i0 + b2 * i1 + b3 * i2
				- a2 * o1 - a3 * o2;// + 1e-37;
			/*
			if (isnan(o0) || ABS(isinf(o0)))
				o0 = 1e-37;
				*/
			AUBIO_DBG("%f\n", o0);
			in->data[i][j] = o0;
			i2 = i1;
			i1 = i0;
			o2 = o1;
			o1 = o0;
		}
		b->i2 = i2;
		b->i1 = i1;
		b->o2 = o2;
		b->o1 = o1;
	//}
}

biquad_t * new_biquad(float b1, float b2, float b3, float a2, float a3) {
	biquad_t * b = AUBIO_NEW(biquad_t);
	b->b1 = b1;
	b->b2 = b2;
	b->b3 = b3;
	b->b2 = b2;
	b->b3 = b3;
	b->i1 = 0.0;
	b->i2 = 0.0;
	b->o1 = 0.0;
	b->o2 = 0.0;
	return b;
}
