/*
	 Copyright (C) 2003 Paul Brossier

	 This program is free software; you can redistribute it and/or modify
	 it under the terms of the GNU General Public License as published by
	 the Free Software Foundation; either version 2 of the License, or
	 (at your option) any later version.

	 This program is distributed in the hope that it will be useful,
	 but WITHOUT ANY WARRANTY; without even the implied warranty of
	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 GNU General Public License for more details.

	 You should have received a copy of the GNU General Public License
	 along with this program; if not, write to the Free Software
	 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
	 */

/** @file
 *
 * Histogram function
 *
 * Big hacks to implement an histogram
 */

#ifndef HIST_H
#define HIST_H

#include "sample.h"

/** histogram object */
typedef struct _hist_t hist_t;

/** histogram creation 
 * \param flow minimum input
 * \param fhig maximum input
 * \param nelems number of histogram columns
 * \param channels number of channels 
 */
extern hist_t * hist_new(float flow, float fhig, int nelems, int channels);
/** histogram deletion */
extern void hist_delete(hist_t *s);
extern void hist_do(hist_t *s, fvec_t * input);
extern void hist_do_notnull(hist_t *s, fvec_t * input);
extern float hist_mean(hist_t *s); 
extern void hist_weigth(hist_t *s); 
void hist_dyn_notnull (hist_t *s, fvec_t *input);

#endif
