
#ifndef PEAKPICK_H
#define PEAKPICK_H

#include "aubio_priv.h"
#include "mathutils.h"
#include "sample.h"

typedef float (*aubio_thresholdfn_t)(fvec_t *input);
typedef int (*aubio_pickerfn_t)(fvec_t *input, int pos);
typedef struct _pickparams_t pickparams_t;

pickparams_t * new_aubio_peakpicker(void);
int peakpick(fvec_t * input, int pos);
float local_energy(fvec_t * f);
float local_hfc(fvec_t * f);
float alpha_norm(fvec_t * DF, float alpha);
float samerpp(fvec_t * DF, pickparams_t * p);
int pimrt(fvec_t * DF, pickparams_t * p);


#endif /* PEAKPICK_H */
